from tkinter import *
from tkinter.filedialog import askopenfilename, askdirectory
from tkinter import messagebox

import os
import shutil
import logging
import platform
import subprocess
import json

import register
import hashlib
from cryptography.fernet import Fernet
import os

if not os.path.isdir('logs'):
    os.makedirs("logs")


class RegisterWindow:
    def __init__(self):
        self.root = Tk()
        self.root.title("Register Screen")

    def _login(self):
        self.root.destroy()

        window = LoginWindow()
        window.add_elements()
        window.run()

    def _register(self):
        name = self.username_username.get()
        password = self.password_username.get()
        worker = self.worker_username.get()
        email = self.email_username.get()

        register.add_user({"name": name, "password": password,
                          "worker_id": worker, "email_id": email})

        self.root.destroy()

        window = MainWindow(worker)
        window.add_elements()
        window.run()

    def add_elements(self):
        self.username_text = Label(text="Enter Username:")
        self.username_text.grid(row=0, column=0)
        self.username_username = Entry()
        self.username_username.grid(row=0, column=1)

        self.password_text = Label(text="Enter Password:")
        self.password_text.grid(row=1, column=0)
        self.password_username = Entry()
        self.password_username.grid(row=1, column=1)

        self.worker_text = Label(text="Enter Worker Id:")
        self.worker_text.grid(row=2, column=0)

        self.worker_username = Entry()
        self.worker_username.grid(row=2, column=1)

        self.email_text = Label(text="Enter Email Id:")
        self.email_text.grid(row=3, column=0)

        self.email_username = Entry()
        self.email_username.grid(row=3, column=1)

        self.register_button = Button(
            text="Register", command=self._register)
        self.register_button.grid(row=4, column=0, columnspan=2)

        self.login_button = Button(
            text="Login Instead", command=self._login)
        self.login_button.grid(row=5, column=0, columnspan=2)

    def run(self):
        self.root.mainloop()


class LoginWindow:


    def __init__(self):
        self.root = Tk()
        self.root.title("Login Screen")

   # def encrypt(self, arg):
       # mydir = 'C:/Users/New User/Desktop/Projects 4th Year/Tkinter File Traverser/logs'
       # myfile = 'admin.json'
        #admin_path = os.path.join(mydir, myfile)

        #this generates a key and opens a file 'key.key' and writes the key there
        #key = Fernet.generate_key()
        #file = open('key.key','wb')
        #file.write(key)
        #file.close()

        #this just opens the 'key.key' and assings the key stored there as 'key'
        #file = open('key.key','rb')
        #key = file.read()
        #file.close()

        #this opens the json and reads its data into a new variable called 'data'
        #with open(admin_path,'rb') as f:
            #data = f.read()

        #this encrypts the data read from the json and stores it in 'encrypted'
        #fernet = Fernet(key)
        #encrypted=fernet.encrypt(data)

        #this writes the new, encrypted data into a new JSON file
        #with open('admin.json','wb') as f:
            #f.write(encrypted)


    #def decrypt(self, arg):

        #mydir = 'C:/Users/New User/Desktop/Projects 4th Year/Tkinter File Traverser/logs'
        #myfile = 'admin.json'
        #admin_path = os.path.join(mydir, myfile)

        #this just opens the 'key.key' and assings the key stored there as 'key'
        #file = open('key.key','rb')
        #key = file.read()
        #file.close()

        # value of key is assigned to a variable
        #f = Fernet(key)

        #this opens the json and reads its data into a new variable called 'data'
        #with open(admin_path,'rb') as f:
            #data = f.read()

        #this decrypts the data read from the json 
        #fernet = Fernet(key)
        #decrypted=fernet.decrypt(data)

        #this writes the new, encrypted data into a new JSON file
        #with open('admin.json','wb') as f:
            #f.write(decrypted)
    

    def _login(self):

        #mydir = 'C:/Users/New User/Desktop/Projects 4th Year/Tkinter File Traverser/logs'
        #myfile = 'admin.json'
        #admin_path = os.path.join(mydir, myfile)
        #self.decrypt(admin_path)
        name = self.username_username.get()
        password = self.password_username.get()
        worker = self.worker_username.get()

        result = register.check_user({"name": name, "password": password,
                                      "worker_id": worker})

        if result:
            self.root.withdraw()

            window = MainWindow(worker)
            window.add_elements()
            window.run()
            #self.encrypt(admin_path)
        else:
            messagebox.showerror("Wrong Credentails",
                                 "The credentails you provided were wrong")

      


    def add_elements(self):
        self.username_text = Label(text="Enter Username:")
        self.username_text.grid(row=0, column=0)
        self.username_username = Entry()
        self.username_username.grid(row=0, column=1)

        self.password_text = Label(text="Enter Password:")
        self.password_text.grid(row=1, column=0)
        self.password_username = Entry()
        self.password_username.grid(row=1, column=1)

        self.worker_text = Label(text="Enter Worker Id:")
        self.worker_text.grid(row=2, column=0)

        self.worker_username = Entry()
        self.worker_username.grid(row=2, column=1)

        self.register_button = Button(
            text="Login", command=self._login)
        self.register_button.grid(row=3, column=0, columnspan=2)

    def run(self):
        self.root.mainloop()


class MainWindow:
    def __init__(self, user):
        self.user = user

        self.root = Tk()
        self.root.title("Options Screen")

        with open(f'C:/Users/New User/Desktop/Projects 4th Year/Tkinter File Traverser/logs/{self.user}.log', 'w') as _:
            pass

        logging.basicConfig(filename=f'C:/Users/New User/Desktop/Projects 4th Year/Tkinter File Traverser/logs/{self.user}.log', level=logging.INFO,
                            format='%(asctime)s:%(levelname)s:%(message)s')
        logging.info(f'{self.user} has logged in')

    def _file_selection_handler(self):
        self.root.withdraw()
        filepath = askopenfilename()
        self.root.deiconify()

        if platform.system() == 'Darwin':
            subprocess.call(('open', filepath))  # For Mac OS
        elif platform.system() == 'Windows':
            os.startfile(filepath)  # For Windows
        else:
            subprocess.call(('xdg-open', filepath))  # For Linux

        logging.info(f'{self.user} has opened {filepath}')

    #def _file_hash(self):
        #self.root.withdraw()
        #filepath = askopenfilename()
        #self.root.deiconify()

        #if platform.system() == 'Darwin':
            #subprocess.call(('open', filepath))  # For Mac OS
        #elif platform.system() == 'Windows':
            #os.startfile(filepath)  # For Windows
        #else:
            #subprocess.call(('xdg-open', filepath))  # For Linux

        #file = open()          # Location of the file
        #BLOCK_SIZE = 65536 # The size of each read from the file, to prevent it hashing the entire file at once

        #file_hash = hashlib.sha256() # Create the hash object using sha256
        #with open(file, 'rb') as f: # Open the file to read it's bytes
        #fb = f.read(BLOCK_SIZE) # Read from the file. Take in the amount declared above
        #while len(fb) > 0: # While there is still data being read from the file
        #file_hash.update(fb) # Update the hash
        #fb = f.read(BLOCK_SIZE) # Read the next block from the file

        #file = open('key.key','wb')
        #file.write(file_hash)
        #file.close()

        #print (file_hash.hexdigest()) # Get the hexadecimal digest of the hash

        #logging.info(f'{self.user} has hashed {filepath}')


    def _transfer_files(self):
        src = askdirectory()
        dest = askdirectory()

        try:
            shutil.copytree(src, os.path.join(dest, os.path.split(src)[-1]))
        except Exception:
            pass
        else:
            logging.info(
                f'{self.user} has copied {src} to {os.path.join(dest, os.path.split(src)[-1])}')

    def add_elements(self):
        self.file_selection = Button(
            self.root, text="File Selection", command=self._file_selection_handler)
        self.file_selection.grid(row=1, column=0)

        self.phone_files = Button(
            self.root, text="Copy Folders from Phone", command=self._transfer_files)
        self.phone_files.grid(row=2, column=0)

    def run(self):
        self.root.mainloop()


win = RegisterWindow()
win.add_elements()
win.run()
